var checkTabTimerId = null;
var indexedDB = window.indexedDB;
var IDBTransaction = window.IDBTransaction;
var DB;
var openRequest = indexedDB.open("bookmarkdb",1);
var sendtagsarray = [];
var sendflag = false;
var searchbookmarflag = false;
var omniboxtext = null;
var firstsuggest = null;
var contextmenuid = null;

window.addEventListener("load", function() {
    var optobj = localStorage.getItem("option_object");
    if(optobj){
        var optionobj = JSON.parse(optobj);
    	if(optionobj.cntxt){
			createContextMenu();
    	}
    	if(optionobj.addrsbr == "bookmark"){
    		searchbookmarflag = true;
    	}
    }else{
		createContextMenu();
    }
});
function checkCurrentTabStatus(){
	// chrome.tabs.query({active: true, currentWindow: true},function(tabs){
	// 	var tabid = tabs[0].id;
	// 	var turl = tabs[0].url;
	// 	chrome.bookmarks.search(turl, function(bknd){
	// 		var len = bknd.length;
	// 		var flg = false;
	// 		if(len > 0){
	// 			for(var i = 0; i < len; i++){
	// 				if(bknd[i].url == turl){
	// 					flg = true;
	// 				}
	// 			}
	// 		}
	// 		if(flg){
	// 			chrome.browserAction.setIcon({tabId: tabid, path: 'icon19on.png'});
	// 		}else{
	// 			chrome.browserAction.setIcon({tabId: tabid, path: 'icon19off.png'});
	// 		}
	// 	});
	// });
}
openRequest.onupgradeneeded = function(e) {
	var thisDb = e.target.result;
	if(!thisDb.objectStoreNames.contains("bookmark")) {
		var objectStore = thisDb.createObjectStore("bookmark", { keyPath: "id", autoIncrement:false });  
		objectStore.createIndex("tags","tags", {unique:false,multiEntry:true});			
	}
}
openRequest.onsuccess = function(e) {
	DB = e.target.result;
	DB.onerror = function(e) {
		sendflag = false;
		sendtagsarray.length = 0;
	};
}
function addData(bkid,tags,title,url) {
	if((bkid)&&(url)){
		var transaction = DB.transaction(["bookmark"], "readwrite");
		var objectStore = transaction.objectStore("bookmark");
		var req = objectStore.put({id:bkid, tags:tags, title:title, url: url});
		req.onsuccess = function(e) {};
	}
}
function setSendFlag(){
	sendtagsarray.length = 0;
	sendflag = true;
}
function checkSendFlag (){
	return sendflag;
}
function sendTagArray(){
	var newary = sendtagsarray.concat();
	sendtagsarray.length = 0;
    sendflag = false;
	return newary;
}
function getByTag(tag) {
	var transaction = DB.transaction(["bookmark"], "readonly");
	var objectStore = transaction.objectStore("bookmark");
	var index = objectStore.index("tags");
	var rangeTest = IDBKeyRange.only(tag);
	index.openCursor(rangeTest).onsuccess = function(e) {
		var cursor = e.target.result;
		if (cursor) {
			sendtagsarray.push(cursor.value);
			cursor.continue();
		}else{
		    sendflag = false;
		}
	};
	index.openCursor(rangeTest).onerror = function(e) {
	    sendflag = false;
	};
}
function getByID(id){
	var transaction = DB.transaction(["bookmark"], "readonly");
	var objectStore = transaction.objectStore("bookmark");
	var req = objectStore.get(id);
	req.onsuccess = function(e){
		var rslt = e.target.result;
	    if((rslt)&&(rslt.tags)&&(rslt.tags.length > 0)){
	    	sendtagsarray = rslt.tags;
	    }else{
	    	sendtagsarray.length = 0;
	    }
	    sendflag = false;
	};
	req.onerror = function(e){
    	sendtagsarray.length = 0;
	    sendflag = false;
	}
}
function showAll() {
	var transaction = DB.transaction(["bookmark"], "readonly");
	var objectStore = transaction.objectStore("bookmark");
	var request = objectStore.openCursor();
	request.onsuccess = function(e) {
		var cursor = e.target.result;
		if (cursor) {
			sendtagsarray.push(cursor.value);
			cursor.continue();
		}else{
		    sendflag = false;
		}
	};
	request.onerror = function(e){
	    sendflag = false;
	};
}
function deleteData(id){
	var transaction = DB.transaction(["bookmark"], "readwrite");
	var objectStore = transaction.objectStore("bookmark");
    var req = objectStore.delete(id);
    req.onsuccess = function() {
    };
}
function deleteObjectStore(){
    var trans = DB.transaction(["items"], "readwrite");
    var store = trans.objectStore("items");
    var request = store.clear();
    request.onsuccess = function (e) {
    }
}
var setSuggest = function(description){
	chrome.omnibox.setDefaultSuggestion({description: description});
};
var resetSuggest = function(){
	omniboxtext = null;
	firstsuggest = null;
	if(!searchbookmarflag){
		var description = '<match>Enter bookmark tags</match><dim>[</dim>default tag 1 = Bookmarks bar, 2 = Other bookmarks, 3 = Recent bookmarks, 4 = Search <dim>[</dim>keyword<dim>]</dim><dim>]</dim>';	
	}else{
		var description = '<match>Search bookmarks</match>';
	}
	setSuggest(description);
};
var xmlEncode = function (text){
	if(text){
		return text.replace(/&/gi, '&amp;').replace(/\"/gi, '&quot;').replace(/\'/gi, '&apos;').replace(/</gi, '&lt;').replace(/>/gi, '&gt;');
	}else{
		return "";
	}
}
chrome.omnibox.onInputChanged.addListener(function(inputvalue, suggest){
	omniboxtext = inputvalue;
	if (inputvalue&&(inputvalue.length > 0)){
		var content = inputvalue.replace(/^\s+|\s+$/g, "").replace(/(\s{2,}|\s+$)/, ' ').split(' ');
		var value = content[0];

		if((value == "1")||(value == "2")){
			chrome.bookmarks.getChildren(value, function (bkary){
				checkBookmark(bkary,suggest);
			});
		}else if(value == "3"){
			chrome.bookmarks.getRecent(15, function (bkary){
				checkBookmark(bkary,suggest);
			});
		}else{
			if(searchbookmarflag){
				chrome.bookmarks.search(value, function (bkary){
					checkBookmark(bkary,suggest);
				});
			}else if(value.indexOf("4") == 0){
				var description = '<match>Search</match><dim>[</dim> Space <match>keywords</match><dim>]</dim><dim>]</dim>';
				setSuggest(description);
				var nvalue = content[1];
				if(nvalue){
					chrome.bookmarks.search(nvalue, function (bkary){
						checkBookmark(bkary,suggest);
					});
				}
			}else{
				getByTag(value);
				var results = [];
				function getByTag(tag) {
					var transaction = DB.transaction(["bookmark"], "readonly");
					var objectStore = transaction.objectStore("bookmark");
					var index = objectStore.index("tags");
					var rangeTest = IDBKeyRange.only(tag);
					index.openCursor(rangeTest).onsuccess = function(e) {
						var cursor = e.target.result;
						if (cursor) {
							var flg = true;
							if(content.length > 1){
								for(var i = 1; i < content.length; i++){
									flg = false;
									for(var ii = 0; ii < cursor.value.tags.length; ii++){
										if(content[i] == cursor.value.tags[ii]){
											flg = true;
											break;
										}
									}
									if(!flg){
										break;
									}
								}
							}
							if(flg){
								results.push(cursor.value);
							}
							cursor.continue();
						}else{
							if(results.length > 0){
								createSuggest(results,suggest);
							}else{
								resetSuggest();
								suggest([]);
							}
						}
					}
				}
			}
		}
	}else{
		resetSuggest();
		suggest([]);
	}
	function checkBookmark(bkary,suggest){
		if(bkary&&(bkary.length > 0)){
			var len = bkary.length;
			var results = [];
			var ttlary = [];

			for(var i = 0; i < len; i++){
				var bkurl = bkary[i].url;
				if(bkurl){
					var bkttl = bkary[i].title;
					if(ttlary.indexOf(bkttl) == -1){
						ttlary.push(bkttl)
						results.push(bkary[i]);
					}
				}
			}
			if (results.length > 0){
				createSuggest(results,suggest);
			}else{
				resetSuggest();
				suggest([]);
			}
		}else{
			resetSuggest();
			suggest([]);
		}
	}
	function createSuggest(results,suggest){
		if (results.length > 5){
			results = results.slice(0, 5);
		}
		var suggestions = [];
		for (var i=0, l=results.length; i<l; i++){
			var result = results[i];
			var url = xmlEncode(result.url);
			var des = createxml(result);
			suggestions.push({
				content: url,
				description: des
			});
		}
		var fsugst = suggestions.shift();
		firstsuggest = fsugst;
		setSuggest(fsugst.description);
		suggest(suggestions);
		function createxml(result){
			var title = xmlEncode(result.title);
			var url = xmlEncode(result.url);
			return '<match>'+title+'</match> <dim>-</dim> <url>'+url+'</url>';
		}
	}
});
chrome.omnibox.onInputEntered.addListener(function(text){
	if(text){
		var url;
    	if(text.match(/^(http|https|file):\/\/.+$/)){
			url = text;
	    }else if(text.indexOf("javascript:") == 0){
	        chrome.tabs.update(null, { url: text});
			resetSuggest();
            return;
		}else{
			if(firstsuggest){
				text = text.replace(/^\s+|\s+$/g, "");
				omniboxtext = omniboxtext.replace(/^\s+|\s+$/g, "");
				if(text == omniboxtext){
					url = firstsuggest.content;
				}else{
					url = "https://www.google.com/search?q="+text;
				}
			}
		}
		chrome.tabs.query({active:true,currentWindow:true}, function(tabs){
			chrome.tabs.update(tabs[0].id, {
				url: url,
				highlighted: true
			});
		});
	}
});
window.addEventListener("load", function(){
    clearTimeout(checkTabTimerId);
    checkTabTimerId = setTimeout(checkCurrentTabStatus,600);
}, false);
chrome.windows.onFocusChanged.addListener(function(windowId) {
    clearTimeout(checkTabTimerId);
    checkTabTimerId = setTimeout(checkCurrentTabStatus,200);
});
chrome.tabs.onActivated.addListener(function(activeInfo) {
    clearTimeout(checkTabTimerId);
    checkTabTimerId = setTimeout(checkCurrentTabStatus,200);
});
chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
    if (changeInfo.status == "loading") {
        clearTimeout(checkTabTimerId);
        checkTabTimerId = setTimeout(checkCurrentTabStatus,200);
    }
});
chrome.bookmarks.onCreated.addListener(function (){
	checkCurrentTabStatus();
});
chrome.bookmarks.onRemoved.addListener(function (){
	checkCurrentTabStatus();
});
chrome.bookmarks.onChildrenReordered.addListener(function (){
	checkCurrentTabStatus();
});
chrome.bookmarks.onImportEnded.addListener(function (){
	checkCurrentTabStatus();
});
chrome.commands.onCommand.addListener(function(command) {
    if(command == "myCommandADDBOOKMARK"){
    	addCurrentPage();
    }else if(command == "myCommandADDBOOKMARKtabs"){
    	addCurrentTabs();
    }
});
function addCurrentPage(){
	chrome.tabs.query({active: true, currentWindow: true},function(tabs){
		var url = tabs[0].url;
		var title = tabs[0].title;
		chrome.bookmarks.search(url, function(bknds){
			var len = bknds.length;
			var flg = false;
			if(len > 0){
				for(var i = 0; i < len; i++){
					if(bknds[i].url == url){
						flg = true;
						break;
					}
				}
			}
			if(!flg){
				chrome.bookmarks.create({title:title, url: url, parentId: "1"},function(){
					checkCurrentTabStatus();
				});
			}
		});
	});
}
function addCurrentTabs(){
	chrome.tabs.query({currentWindow: true,active:true},function(t){
		chrome.tabs.query({currentWindow: true},function(tabs){
			var len = tabs.length;
			if(len > 0){
				chrome.bookmarks.create({title:t[0].title, parentId: "1"},function(bknd){
					var prntid = bknd.id;
					for(var i = 0; i < len; i++){
						var ttl = tabs[i].title;
						var url = tabs[i].url;
						chrome.bookmarks.create({title:ttl,url:url, parentId: prntid});
					}
				});
			}
		});
	});
}
function removeContextMenu(){
	contextmenuid = null;
	chrome.contextMenus.removeAll();
}
function createContextMenu(){
	if(!contextmenuid){
	    contextmenuid = chrome.contextMenus.create({
	        "contexts": ["all"],
	        "title": "Add Current Page",
	        "type": "normal",
	        "onclick":function(e){
		    	addCurrentPage();
	        }
	    }); 
	}
}
function setSearchBookmarksFlag(set){
	searchbookmarflag = set;
}
function openOptionsPage(){
    var extviews = chrome.extension.getViews({"type": "tab"});
    for (var i=0; i <= extviews.length; i++) { 
        if (i == extviews.length) { 
            chrome.tabs.create({
                url: "options.html"
            });
        }else if (extviews[i].location.href == chrome.extension.getURL("options.html")) { 
            extviews[i].chrome.tabs.getCurrent(function (focusTab){
                chrome.tabs.update(focusTab.id, {"active": true}); 
            }); 
            break; 
        } 
    } 
}
chrome.runtime.onInstalled.addListener(function(details) {
    if(details.reason == "install"){
    	openOptionsPage();
    }
});
