window.addEventListener("load", function () {
    document.getElementById("fntstyleselect").addEventListener("change",changeFontFace,false);
    document.getElementById("popupwidthinpt").addEventListener("change",changeWidht,false);
    document.getElementById("leftclickselect").addEventListener("change",changeLClick,false);
    document.getElementById("ctrlclickselect").addEventListener("change",changeCTRLLClick,false);
    document.getElementById("shiftclickselect").addEventListener("change",changeShiftLClick,false);
    document.getElementById("middleclickselect").addEventListener("change",changeMClick,false);
    document.getElementById("remembercheckbutton").addEventListener("change",changeRemember,false);
    document.getElementById("stayopencheckbutton").addEventListener("change",changeStayOpen,false);
    document.getElementById("zoominpt").addEventListener("change",changeZoom,false);
    document.getElementById("expandfolder").addEventListener("change",changeExpandingFolder,false);
    document.getElementById("openfolderact").addEventListener("change",changeOpenFolderAct,false);
    document.getElementById("detecttimeinpt").addEventListener("change",changeDelayOpen,false);
    document.getElementById("mobilebkcheckbutton").addEventListener("change",changeMobileBookmark,false);
    document.getElementById("tooltipcheckbutton").addEventListener("change",changeTooltip,false);
    document.getElementById("recentbkcheckbutton").addEventListener("change",changeRecentBookmark,false);
    document.getElementById("minheightinpt").addEventListener("change",changeMinHeight,false);
    document.getElementById("contextmenucheckbutton").addEventListener("change",changeContextMenu,false);
    document.getElementById("addressbar").addEventListener("change",changeAddressBarSearch,false);
    document.getElementById("changefolderselect").addEventListener("change",changeFolderIcon,false);
    var optobj = localStorage.getItem("option_object");
    if(optobj){
        optionobj = JSON.parse(optobj);
    }else{
        loadDefault();
    }
    setElementValue();
    setColorRange(0);
    setColorRange(1);
}, false);

var optionobj = {};
var savetimerid = null;
var bgpage = chrome.extension.getBackgroundPage();

function loadDefault(){
    optionobj.bgcolor = "rgb(255,255,255)";
    optionobj.fntcolor = "rgb(0,0,0)";
    optionobj.ctrlclick = "newback";
    optionobj.dettime = "350";
    optionobj.expfld = "1";
    optionobj.fontface = "Arial,sans-serif";
    optionobj.lclick = "current";
    optionobj.mclick = "newback";
    optionobj.mobile = false;
    optionobj.opfact = "hover";
    optionobj.remem = false;
    optionobj.shftclick = "newwind";
    optionobj.stayo = false;
    optionobj.tooltip = false;
    optionobj.widht = "282";
    optionobj.zoom = "100";
    optionobj.recent = true;
    optionobj.mheight = "145";
    optionobj.cntxt = true;
    optionobj.addrsbr = "tag";
}
function setElementValue(){
    (function(){
        var bgstr = optionobj.bgcolor;
        var rgbary = bgstr.split(",");
        var bgrval = parseInt(rgbary[0].substring(4),10);
        var bggval = parseInt(rgbary[1],10);
        var bgbval = parseInt(rgbary[2].slice(0, -1),10);

        var fntstr = optionobj.fntcolor;
        var rgbary =  fntstr.split(",");
        var fntrval = parseInt(rgbary[0].substring(4),10);
        var fntgval = parseInt(rgbary[1],10);
        var fntbval = parseInt(rgbary[2].slice(0, -1),10);

        document.getElementById("bgredrange").value = bgrval;
        document.getElementById("bggreenrange").value = bggval;
        document.getElementById("bgbluerange").value = bgbval;
        document.getElementById("fntredrange").value = fntrval;
        document.getElementById("fntgreenrange").value = fntgval;
        document.getElementById("fntbluerange").value = fntbval;
    })();
    document.getElementById("ctrlclickselect").value = optionobj.ctrlclick;
    document.getElementById("detecttimeinpt").value = parseInt(optionobj.dettime,10);
    document.getElementById("expandfolder").value = optionobj.expfld;
    document.getElementById("fntstyleselect").value = optionobj.fontface;
    document.getElementById("leftclickselect").value = optionobj.lclick;
    document.getElementById("middleclickselect").value = optionobj.mclick;
    document.getElementById("mobilebkcheckbutton").checked = optionobj.mobile;
    document.getElementById("openfolderact").value = optionobj.opfact;
    if(optionobj.opfact != "hover"){
        document.getElementById("detecttimecontainer").style.visibility = "hidden";
    }
    document.getElementById("remembercheckbutton").checked = optionobj.remem;
    document.getElementById("shiftclickselect").value = optionobj.shftclick;
    document.getElementById("stayopencheckbutton").checked = optionobj.stayo;
    document.getElementById("tooltipcheckbutton").checked = optionobj.tooltip;
    document.getElementById("popupwidthinpt").value = parseInt(optionobj.widht,10);
    document.getElementById("zoominpt").value = parseInt(optionobj.zoom,10);
    document.getElementById("recentbkcheckbutton").checked = optionobj.recent;
    document.getElementById("minheightinpt").value = optionobj.mheight;
    document.getElementById("contextmenucheckbutton").checked = optionobj.cntxt;
    document.getElementById("addressbar").value = optionobj.addrsbr;

    if(optionobj.fldicon){
	    document.getElementById("changefolderselect").value = "normal";
    }
}

function changeFolderIcon(e){
    var val = this.value;
    if(this.value == "normal"){
	    optionobj.fldicon = val;
    }else{
    	delete optionobj.fldicon;
    }
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeAddressBarSearch(e){
    var val = this.value;
    optionobj.addrsbr = val;
    localStorage.setItem("option_object",JSON.stringify(optionobj));
    if(val == "tag"){
        bgpage.setSearchBookmarksFlag(false);
    }else{
        bgpage.setSearchBookmarksFlag(true);
    }
}
function changeContextMenu(e){
    var val = this.checked;
    optionobj.cntxt = val;
    localStorage.setItem("option_object",JSON.stringify(optionobj));
    if(val){
        bgpage.createContextMenu();
    }else{
        bgpage.removeContextMenu();
    }
}
function changeMinHeight(e){
    var val = this.value;
    if((530 < val)||(145 > val)){
        val = 145;
        this.value = 145;
    }
    optionobj.mheight = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeRecentBookmark(e){
    var val = this.checked;
    optionobj.recent = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeZoom(e){
    var val = this.value;
    if((300 < val)||(50 > val)){
        val = 100;
        this.value = 100;
    }
    optionobj.zoom = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeTooltip(e){
    var val = this.checked;
    optionobj.tooltip = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeMobileBookmark(e){
    var val = this.checked;
    optionobj.mobile = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeDelayOpen(e){
    var val = this.value;
    if((3000 < val)||(1 > val)){
        val = 350;
        this.value = 350;
    }
    optionobj.dettime = val;
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeOpenFolderAct(e){
    optionobj.opfact = this.value;
    if(this.value == "hover"){
        document.getElementById("detecttimecontainer").style.visibility = "visible";
    }else{
        document.getElementById("detecttimecontainer").style.visibility = "hidden";
    }
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeExpandingFolder(e){
    optionobj.expfld = this.value;
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeStayOpen(e){
    var val = this.checked;
    optionobj.stayo = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeRemember(e){
    var val = this.checked;
    optionobj.remem = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeLClick(e){
    var val = this.value;
    optionobj.lclick = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeCTRLLClick(e){
    var val = this.value;
    optionobj.ctrlclick = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeShiftLClick(e){
    var val = this.value;
    optionobj.shftclick = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeMClick(e){
    var val = this.value;
    optionobj.mclick = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeWidht(e){
    var val = this.value;
    if((400 < val)||(100 > val)){
        val = 282;
        this.value = 282;
    }
    optionobj.widht = val
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function changeFontFace(e){
    optionobj.fontface = this.value;
    localStorage.setItem("option_object",JSON.stringify(optionobj));
}
function setColorRange(a) {
    var b = document.getElementById("bgredrange").value;
    var c = document.getElementById("bggreenrange").value;
    var d = document.getElementById("bgbluerange").value;
    var f = document.getElementById("fntredrange").value;
    var g = document.getElementById("fntgreenrange").value;
    var h = document.getElementById("fntbluerange").value;
    var i = document.getElementById("samplecolorcontainer");
    if (a == 0) {
        var j = document.getElementById("bgredrange");
        var k = document.getElementById("bggreenrange");
        var l = document.getElementById("bgbluerange");
        var m = b;
        var n = c;
        var o = d
    } else {
        var j = document.getElementById("fntredrange");
        var k = document.getElementById("fntgreenrange");
        var l = document.getElementById("fntbluerange");
        var m = f;
        var n = g;
        var o = h
    }
    var p = function (e) {
        m = parseInt(this.value);
        s()
    };
    var q = function (e) {
        n = parseInt(this.value);
        s()
    };
    var r = function (e) {
        o = parseInt(this.value);
        s()
    };
    var s = function () {
        if (a == 0) {
            i.style.backgroundColor = "rgb(" + m + "," + n + "," + o + ")";
            optionobj.bgcolor = "rgb(" + m + "," + n + "," + o + ")";
        } else {
            i.style.color = "rgb(" + m + "," + n + "," + o + ")";
            optionobj.fntcolor = "rgb(" + m + "," + n + "," + o + ")";
        }
        clearTimeout(savetimerid);
        savetimerid = setTimeout(function(){
            localStorage.setItem("option_object",JSON.stringify(optionobj));         
        },300);
    };
    j.addEventListener("change", p, false);
    k.addEventListener("change", q, false);
    l.addEventListener("change", r, false);
    s()
}
